package com.fp.persistence.pgeneral.menu;

import javax.persistence.Column;
import java.io.Serializable;
import com.fp.dto.hb.HibernateId;
import java.lang.reflect.Field;
import javax.persistence.Embeddable;
import javax.persistence.Transient;

/**Clase que hace referencia a la Clave Primaria de TGENEMENULEVELDESC*/
@Embeddable
public class TgeneMenuLevelDescKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="MENUCODE", nullable=false,updatable=false)

/**
* Codigo de menu
*/
private Integer menucode;

@Column(name="LEVELCODE", nullable=false,updatable=false)

/**
* Codigo de nivel del menu
*/
private Integer levelcode;

@Column(name="LANGUAGECODE", nullable=false,updatable=false)

/**
* Codigo de idioma
*/
private String languagecode;

/**Contructor por defecto*/
public TgeneMenuLevelDescKey(){}
/**Contructor de TgeneMenuLevelDescKey
@param pMenucode Codigo de menu
@param pLevelcode Codigo de nivel del menu
@param pLanguagecode Codigo de idioma
*/
public TgeneMenuLevelDescKey(Integer pMenucode,Integer pLevelcode,String pLanguagecode){
 menucode=pMenucode;
 levelcode=pLevelcode;
 languagecode=pLanguagecode;
}
/**Obtiene el valor de menucode
@return valor de menucode*/
public Integer getMenucode(){
  return menucode;
}
/**Fija el valor de menucode
@param pMenucode nuevo Valor de menucode*/
public void setMenucode(Integer pMenucode){
  menucode=pMenucode;
}

/**Obtiene el valor de levelcode
@return valor de levelcode*/
public Integer getLevelcode(){
  return levelcode;
}
/**Fija el valor de levelcode
@param pLevelcode nuevo Valor de levelcode*/
public void setLevelcode(Integer pLevelcode){
  levelcode=pLevelcode;
}

/**Obtiene el valor de languagecode
@return valor de languagecode*/
public String getLanguagecode(){
  return languagecode;
}
/**Fija el valor de languagecode
@param pLanguagecode nuevo Valor de languagecode*/
public void setLanguagecode(String pLanguagecode){
  languagecode=pLanguagecode;
}

/**Implementación de la comparación de TgeneMenuLevelDescKey
@param o Objeto de comparación
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof TgeneMenuLevelDescKey))return false;
  TgeneMenuLevelDescKey that = (TgeneMenuLevelDescKey) o;
  if (this.getMenucode() == null || that.getMenucode() == null){
      return false;
  }
  if (! this.getMenucode().equals(that.getMenucode())){
    return false;
  }
  if (this.getLevelcode() == null || that.getLevelcode() == null){
      return false;
  }
  if (! this.getLevelcode().equals(that.getLevelcode())){
    return false;
  }
  if (this.getLanguagecode() == null || that.getLanguagecode() == null){
      return false;
  }
  if (! this.getLanguagecode().equals(that.getLanguagecode())){
    return false;
  }
  return true;
}
/**Implementación del método hashCode bajo el patrón de Bloch
@return hashCode de la instancia TgeneMenuLevelDescKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getMenucode() == null ? 0 : this.getMenucode().hashCode());
    result = result * 37 + (this.getLevelcode() == null ? 0 : this.getLevelcode().hashCode());
    result = result * 37 + (this.getLanguagecode() == null ? 0 : this.getLanguagecode().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
}
